package com.kasetoatz.durabilitynotifier.mixin;

import com.kasetoatz.durabilitynotifier.DurabilityNotifier;
import net.minecraft.client.sound.PositionedSoundInstance;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.sound.SoundEvent;
import net.minecraft.util.Identifier;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import java.util.function.Consumer;

@Mixin(ItemStack.class)
public class ItemStackMixin {
    @Inject(method="onDurabilityChange", at= @At("HEAD"))
    public void postMine(int damage, ServerPlayerEntity player, Consumer<Item> breakCallback, CallbackInfo ci)
    {
        ItemStack stack = (ItemStack)(Object)this;
        if ((stack.getMaxDamage() - stack.getDamage()) <= 10)
        {
            if (!DurabilityNotifier.notified.contains(stack))
            {
                DurabilityNotifier.client.getSoundManager().play(PositionedSoundInstance.master(SoundEvent.of(Identifier.of("durabilitynotifier", "critical")), 1.f));
                DurabilityNotifier.notified.add(stack);
            }
        }
        else
        {
            DurabilityNotifier.notified.remove(stack);
        }
    }
}
